"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMplTrifleErrorFromName = exports.getMplTrifleErrorFromCode = exports.KeyMismatchError = exports.DerivedKeyInvalidError = exports.IncorrectOwnerError = exports.InvalidFirstCreatorError = exports.MustBeHolderError = exports.InvalidCollectionError = exports.FailedToBorrowAccountDataError = exports.FailedToSerializeError = exports.ConstraintKeyNotFoundError = exports.CannotBurnPrintEditionError = exports.FreezeAuthorityNotSetError = exports.TransferEffectConflictError = exports.InvalidCollectionMetadataError = exports.FailedToFindTokenAmountError = exports.TokenLimitExceededError = exports.ConstraintAlreadyExistsError = exports.DataTypeMismatchError = exports.FailedToCreatePubkeyError = exports.InvalidUpdateAuthorityError = exports.EscrowConstraintViolationError = exports.InvalidEscrowConstraintError = exports.InvalidEscrowConstraintModelError = exports.InvalidAccountError = exports.NumericalOverflowError = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const codeToErrorMap = new Map();
const nameToErrorMap = new Map();
class NumericalOverflowError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Numerical Overflow', program, cause);
        this.name = 'NumericalOverflow';
        this.code = 0x0;
    }
}
exports.NumericalOverflowError = NumericalOverflowError;
codeToErrorMap.set(0x0, NumericalOverflowError);
nameToErrorMap.set('NumericalOverflow', NumericalOverflowError);
class InvalidAccountError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Invalid account', program, cause);
        this.name = 'InvalidAccount';
        this.code = 0x1;
    }
}
exports.InvalidAccountError = InvalidAccountError;
codeToErrorMap.set(0x1, InvalidAccountError);
nameToErrorMap.set('InvalidAccount', InvalidAccountError);
class InvalidEscrowConstraintModelError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Invalid Escrow Constraint Model', program, cause);
        this.name = 'InvalidEscrowConstraintModel';
        this.code = 0x2;
    }
}
exports.InvalidEscrowConstraintModelError = InvalidEscrowConstraintModelError;
codeToErrorMap.set(0x2, InvalidEscrowConstraintModelError);
nameToErrorMap.set('InvalidEscrowConstraintModel', InvalidEscrowConstraintModelError);
class InvalidEscrowConstraintError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Invalid Escrow Constraint', program, cause);
        this.name = 'InvalidEscrowConstraint';
        this.code = 0x3;
    }
}
exports.InvalidEscrowConstraintError = InvalidEscrowConstraintError;
codeToErrorMap.set(0x3, InvalidEscrowConstraintError);
nameToErrorMap.set('InvalidEscrowConstraint', InvalidEscrowConstraintError);
class EscrowConstraintViolationError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Escrow Constraint Violation', program, cause);
        this.name = 'EscrowConstraintViolation';
        this.code = 0x4;
    }
}
exports.EscrowConstraintViolationError = EscrowConstraintViolationError;
codeToErrorMap.set(0x4, EscrowConstraintViolationError);
nameToErrorMap.set('EscrowConstraintViolation', EscrowConstraintViolationError);
class InvalidUpdateAuthorityError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Invalid Update Authority', program, cause);
        this.name = 'InvalidUpdateAuthority';
        this.code = 0x5;
    }
}
exports.InvalidUpdateAuthorityError = InvalidUpdateAuthorityError;
codeToErrorMap.set(0x5, InvalidUpdateAuthorityError);
nameToErrorMap.set('InvalidUpdateAuthority', InvalidUpdateAuthorityError);
class FailedToCreatePubkeyError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Failed to create pubkey', program, cause);
        this.name = 'FailedToCreatePubkey';
        this.code = 0x6;
    }
}
exports.FailedToCreatePubkeyError = FailedToCreatePubkeyError;
codeToErrorMap.set(0x6, FailedToCreatePubkeyError);
nameToErrorMap.set('FailedToCreatePubkey', FailedToCreatePubkeyError);
class DataTypeMismatchError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Data type mismatch', program, cause);
        this.name = 'DataTypeMismatch';
        this.code = 0x7;
    }
}
exports.DataTypeMismatchError = DataTypeMismatchError;
codeToErrorMap.set(0x7, DataTypeMismatchError);
nameToErrorMap.set('DataTypeMismatch', DataTypeMismatchError);
class ConstraintAlreadyExistsError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Constraint already exists', program, cause);
        this.name = 'ConstraintAlreadyExists';
        this.code = 0x8;
    }
}
exports.ConstraintAlreadyExistsError = ConstraintAlreadyExistsError;
codeToErrorMap.set(0x8, ConstraintAlreadyExistsError);
nameToErrorMap.set('ConstraintAlreadyExists', ConstraintAlreadyExistsError);
class TokenLimitExceededError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Token Limit Exceeded', program, cause);
        this.name = 'TokenLimitExceeded';
        this.code = 0x9;
    }
}
exports.TokenLimitExceededError = TokenLimitExceededError;
codeToErrorMap.set(0x9, TokenLimitExceededError);
nameToErrorMap.set('TokenLimitExceeded', TokenLimitExceededError);
class FailedToFindTokenAmountError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Failed to find Token Amount', program, cause);
        this.name = 'FailedToFindTokenAmount';
        this.code = 0xa;
    }
}
exports.FailedToFindTokenAmountError = FailedToFindTokenAmountError;
codeToErrorMap.set(0xa, FailedToFindTokenAmountError);
nameToErrorMap.set('FailedToFindTokenAmount', FailedToFindTokenAmountError);
class InvalidCollectionMetadataError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Invalid Collection Metadata', program, cause);
        this.name = 'InvalidCollectionMetadata';
        this.code = 0xb;
    }
}
exports.InvalidCollectionMetadataError = InvalidCollectionMetadataError;
codeToErrorMap.set(0xb, InvalidCollectionMetadataError);
nameToErrorMap.set('InvalidCollectionMetadata', InvalidCollectionMetadataError);
class TransferEffectConflictError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Provided Transfer Effects are not compatible', program, cause);
        this.name = 'TransferEffectConflict';
        this.code = 0xc;
    }
}
exports.TransferEffectConflictError = TransferEffectConflictError;
codeToErrorMap.set(0xc, TransferEffectConflictError);
nameToErrorMap.set('TransferEffectConflict', TransferEffectConflictError);
class FreezeAuthorityNotSetError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Freeze Authority Not Set', program, cause);
        this.name = 'FreezeAuthorityNotSet';
        this.code = 0xd;
    }
}
exports.FreezeAuthorityNotSetError = FreezeAuthorityNotSetError;
codeToErrorMap.set(0xd, FreezeAuthorityNotSetError);
nameToErrorMap.set('FreezeAuthorityNotSet', FreezeAuthorityNotSetError);
class CannotBurnPrintEditionError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Cannot burn Print Edition', program, cause);
        this.name = 'CannotBurnPrintEdition';
        this.code = 0xe;
    }
}
exports.CannotBurnPrintEditionError = CannotBurnPrintEditionError;
codeToErrorMap.set(0xe, CannotBurnPrintEditionError);
nameToErrorMap.set('CannotBurnPrintEdition', CannotBurnPrintEditionError);
class ConstraintKeyNotFoundError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Constraint Key Not Found', program, cause);
        this.name = 'ConstraintKeyNotFound';
        this.code = 0xf;
    }
}
exports.ConstraintKeyNotFoundError = ConstraintKeyNotFoundError;
codeToErrorMap.set(0xf, ConstraintKeyNotFoundError);
nameToErrorMap.set('ConstraintKeyNotFound', ConstraintKeyNotFoundError);
class FailedToSerializeError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Failed to serialize', program, cause);
        this.name = 'FailedToSerialize';
        this.code = 0x10;
    }
}
exports.FailedToSerializeError = FailedToSerializeError;
codeToErrorMap.set(0x10, FailedToSerializeError);
nameToErrorMap.set('FailedToSerialize', FailedToSerializeError);
class FailedToBorrowAccountDataError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Failed to borrow account data', program, cause);
        this.name = 'FailedToBorrowAccountData';
        this.code = 0x11;
    }
}
exports.FailedToBorrowAccountDataError = FailedToBorrowAccountDataError;
codeToErrorMap.set(0x11, FailedToBorrowAccountDataError);
nameToErrorMap.set('FailedToBorrowAccountData', FailedToBorrowAccountDataError);
class InvalidCollectionError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Failed to deserialize collection', program, cause);
        this.name = 'InvalidCollection';
        this.code = 0x12;
    }
}
exports.InvalidCollectionError = InvalidCollectionError;
codeToErrorMap.set(0x12, InvalidCollectionError);
nameToErrorMap.set('InvalidCollection', InvalidCollectionError);
class MustBeHolderError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Only the holder is allowed to perform this action', program, cause);
        this.name = 'MustBeHolder';
        this.code = 0x13;
    }
}
exports.MustBeHolderError = MustBeHolderError;
codeToErrorMap.set(0x13, MustBeHolderError);
nameToErrorMap.set('MustBeHolder', MustBeHolderError);
class InvalidFirstCreatorError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Failed to deserialize the first creator', program, cause);
        this.name = 'InvalidFirstCreator';
        this.code = 0x14;
    }
}
exports.InvalidFirstCreatorError = InvalidFirstCreatorError;
codeToErrorMap.set(0x14, InvalidFirstCreatorError);
nameToErrorMap.set('InvalidFirstCreator', InvalidFirstCreatorError);
class IncorrectOwnerError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Incorrect account owner', program, cause);
        this.name = 'IncorrectOwner';
        this.code = 0x15;
    }
}
exports.IncorrectOwnerError = IncorrectOwnerError;
codeToErrorMap.set(0x15, IncorrectOwnerError);
nameToErrorMap.set('IncorrectOwner', IncorrectOwnerError);
class DerivedKeyInvalidError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Derived key invalid', program, cause);
        this.name = 'DerivedKeyInvalid';
        this.code = 0x16;
    }
}
exports.DerivedKeyInvalidError = DerivedKeyInvalidError;
codeToErrorMap.set(0x16, DerivedKeyInvalidError);
nameToErrorMap.set('DerivedKeyInvalid', DerivedKeyInvalidError);
class KeyMismatchError extends umi_1.ProgramError {
    constructor(program, cause) {
        super('Public key does not match expected value', program, cause);
        this.name = 'KeyMismatch';
        this.code = 0x17;
    }
}
exports.KeyMismatchError = KeyMismatchError;
codeToErrorMap.set(0x17, KeyMismatchError);
nameToErrorMap.set('KeyMismatch', KeyMismatchError);
function getMplTrifleErrorFromCode(code, program, cause) {
    const constructor = codeToErrorMap.get(code);
    return constructor ? new constructor(program, cause) : null;
}
exports.getMplTrifleErrorFromCode = getMplTrifleErrorFromCode;
function getMplTrifleErrorFromName(name, program, cause) {
    const constructor = nameToErrorMap.get(name);
    return constructor ? new constructor(program, cause) : null;
}
exports.getMplTrifleErrorFromName = getMplTrifleErrorFromName;
//# sourceMappingURL=mplTrifle.js.map