import { Context, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
export type CreateTrifleAccountInstructionAccounts = {
    escrow: PublicKey;
    metadata: PublicKey;
    mint: PublicKey;
    tokenAccount: PublicKey;
    edition: PublicKey;
    trifleAccount: PublicKey;
    trifleAuthority: Signer;
    constraintModel: PublicKey;
    payer?: Signer;
    tokenMetadataProgram?: PublicKey;
    systemProgram?: PublicKey;
    sysvarInstructions?: PublicKey;
};
export type CreateTrifleAccountInstructionData = {
    discriminator: number;
};
export type CreateTrifleAccountInstructionDataArgs = {};
export declare function getCreateTrifleAccountInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<CreateTrifleAccountInstructionDataArgs, CreateTrifleAccountInstructionData>;
export declare function createTrifleAccount(context: Pick<Context, 'serializer' | 'programs' | 'payer'>, input: CreateTrifleAccountInstructionAccounts): TransactionBuilder;
