import { Context, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { RoyaltyInstruction, RoyaltyInstructionArgs } from '../types';
export type SetRoyaltiesInstructionAccounts = {
    constraintModel: PublicKey;
    payer?: Signer;
    updateAuthority: Signer;
    systemProgram?: PublicKey;
    sysvarInstructions?: PublicKey;
};
export type SetRoyaltiesInstructionData = {
    discriminator: number;
    name: string;
    royalties: Array<[RoyaltyInstruction, bigint]>;
};
export type SetRoyaltiesInstructionDataArgs = {
    name: string;
    royalties: Array<[RoyaltyInstructionArgs, number | bigint]>;
};
export declare function getSetRoyaltiesInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<SetRoyaltiesInstructionDataArgs, SetRoyaltiesInstructionData>;
export declare function setRoyalties(context: Pick<Context, 'serializer' | 'programs' | 'payer'>, input: SetRoyaltiesInstructionAccounts & SetRoyaltiesInstructionDataArgs): TransactionBuilder;
