import { Context, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
export type TransferInInstructionAccounts = {
    trifle: PublicKey;
    trifleAuthority: PublicKey;
    payer?: Signer;
    constraintModel: PublicKey;
    escrow: PublicKey;
    escrowMint?: PublicKey;
    escrowToken?: PublicKey;
    escrowEdition?: PublicKey;
    attributeMint?: PublicKey;
    attributeSrcToken?: PublicKey;
    attributeDstToken?: PublicKey;
    attributeMetadata?: PublicKey;
    attributeEdition?: PublicKey;
    attributeCollectionMetadata?: PublicKey;
    systemProgram?: PublicKey;
    splToken: PublicKey;
    splAssociatedTokenAccount: PublicKey;
    tokenMetadataProgram?: PublicKey;
};
export type TransferInInstructionData = {
    discriminator: number;
    slot: string;
    amount: bigint;
};
export type TransferInInstructionDataArgs = {
    slot: string;
    amount: number | bigint;
};
export declare function getTransferInInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<TransferInInstructionDataArgs, TransferInInstructionData>;
export declare function transferIn(context: Pick<Context, 'serializer' | 'programs' | 'payer'>, input: TransferInInstructionAccounts & TransferInInstructionDataArgs): TransactionBuilder;
