import { Context, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
export type TransferOutInstructionAccounts = {
    trifleAccount: PublicKey;
    constraintModel: PublicKey;
    escrowAccount: PublicKey;
    escrowTokenAccount: PublicKey;
    escrowMint: PublicKey;
    escrowMetadata: PublicKey;
    escrowEdition?: PublicKey;
    payer?: Signer;
    trifleAuthority: PublicKey;
    attributeMint: PublicKey;
    attributeSrcTokenAccount: PublicKey;
    attributeDstTokenAccount: PublicKey;
    attributeMetadata: PublicKey;
    systemProgram?: PublicKey;
    splAssociatedTokenAccount: PublicKey;
    splToken: PublicKey;
    tokenMetadataProgram?: PublicKey;
    sysvarInstructions?: PublicKey;
};
export type TransferOutInstructionData = {
    discriminator: number;
    slot: string;
    amount: bigint;
};
export type TransferOutInstructionDataArgs = {
    slot: string;
    amount: number | bigint;
};
export declare function getTransferOutInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<TransferOutInstructionDataArgs, TransferOutInstructionData>;
export declare function transferOut(context: Pick<Context, 'serializer' | 'programs' | 'payer'>, input: TransferOutInstructionAccounts & TransferOutInstructionDataArgs): TransactionBuilder;
