"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMplTrifleProgramId = exports.getMplTrifleProgram = exports.createMplTrifleProgram = exports.MPL_TRIFLE_PROGRAM_ID = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const errors_1 = require("../errors");
exports.MPL_TRIFLE_PROGRAM_ID = (0, umi_1.publicKey)('trifMWutwBxkSuatmpPVnEe7NoE3BJKgjVi8sSyoXWX');
function createMplTrifleProgram() {
    return {
        name: 'mplTrifle',
        publicKey: exports.MPL_TRIFLE_PROGRAM_ID,
        getErrorFromCode(code, cause) {
            return (0, errors_1.getMplTrifleErrorFromCode)(code, this, cause);
        },
        getErrorFromName(name, cause) {
            return (0, errors_1.getMplTrifleErrorFromName)(name, this, cause);
        },
        isOnCluster() {
            return true;
        },
    };
}
exports.createMplTrifleProgram = createMplTrifleProgram;
function getMplTrifleProgram(context, clusterFilter) {
    return context.programs.get('mplTrifle', clusterFilter);
}
exports.getMplTrifleProgram = getMplTrifleProgram;
function getMplTrifleProgramId(context, clusterFilter) {
    return context.programs.getPublicKey('mplTrifle', exports.MPL_TRIFLE_PROGRAM_ID, clusterFilter);
}
exports.getMplTrifleProgramId = getMplTrifleProgramId;
//# sourceMappingURL=mplTrifle.js.map