import { Context, GetDataEnumKind, GetDataEnumKindContent, PublicKey, Serializer } from '@metaplex-foundation/umi';
export type EscrowConstraintType = {
    __kind: 'None';
} | {
    __kind: 'Collection';
    fields: [PublicKey];
} | {
    __kind: 'Tokens';
    fields: [Set<PublicKey>];
} | {
    __kind: 'FirstCreator';
    fields: [PublicKey];
};
export type EscrowConstraintTypeArgs = EscrowConstraintType;
export declare function getEscrowConstraintTypeSerializer(context: Pick<Context, 'serializer'>): Serializer<EscrowConstraintTypeArgs, EscrowConstraintType>;
export declare function escrowConstraintType(kind: 'None'): GetDataEnumKind<EscrowConstraintTypeArgs, 'None'>;
export declare function escrowConstraintType(kind: 'Collection', data: GetDataEnumKindContent<EscrowConstraintTypeArgs, 'Collection'>['fields']): GetDataEnumKind<EscrowConstraintTypeArgs, 'Collection'>;
export declare function escrowConstraintType(kind: 'Tokens', data: GetDataEnumKindContent<EscrowConstraintTypeArgs, 'Tokens'>['fields']): GetDataEnumKind<EscrowConstraintTypeArgs, 'Tokens'>;
export declare function escrowConstraintType(kind: 'FirstCreator', data: GetDataEnumKindContent<EscrowConstraintTypeArgs, 'FirstCreator'>['fields']): GetDataEnumKind<EscrowConstraintTypeArgs, 'FirstCreator'>;
export declare function isEscrowConstraintType<K extends EscrowConstraintType['__kind']>(kind: K, value: EscrowConstraintType): value is EscrowConstraintType & {
    __kind: K;
};
