"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isEscrowConstraintType = exports.escrowConstraintType = exports.getEscrowConstraintTypeSerializer = void 0;
function getEscrowConstraintTypeSerializer(context) {
    const s = context.serializer;
    return s.dataEnum([
        ['None', s.unit()],
        [
            'Collection',
            s.struct([['fields', s.tuple([s.publicKey()])]], { description: 'Collection' }),
        ],
        [
            'Tokens',
            s.struct([['fields', s.tuple([s.set(s.publicKey())])]], { description: 'Tokens' }),
        ],
        [
            'FirstCreator',
            s.struct([['fields', s.tuple([s.publicKey()])]], { description: 'FirstCreator' }),
        ],
    ], { description: 'EscrowConstraintType' });
}
exports.getEscrowConstraintTypeSerializer = getEscrowConstraintTypeSerializer;
function escrowConstraintType(kind, data) {
    return Array.isArray(data)
        ? { __kind: kind, fields: data }
        : { __kind: kind, ...(data ?? {}) };
}
exports.escrowConstraintType = escrowConstraintType;
function isEscrowConstraintType(kind, value) {
    return value.__kind === kind;
}
exports.isEscrowConstraintType = isEscrowConstraintType;
//# sourceMappingURL=escrowConstraintType.js.map